from typing import TypeAlias

from mc308.data_structures.formula import *
from mc308.data_structures.ltl import *
from typing import Set, List, Collection



from pysmt.shortcuts import (
    Symbol, get_env,
    Not, And, Iff, Implies, Or
)


def normalize_ltl(formula : LtlFormula, env = get_env()) -> LtlFormula:
    """
    """
    raise NotImplementedError()


def get_sub(formula : LtlFormula, env = get_env()) -> Set[LtlFormula]:
    """ Get all the subformulas formulas of formula """
    raise NotImplementedError()


def closure(formula : LtlFormula) -> Set[LtlFormula]:
    subs = get_sub(formula)
    res = set([s for s in subs] + [Not(f.simplify()) for f in subs])
    return res


def is_elementary(closure : Set[LtlFormula], B : Collection[LtlFormula] ) -> bool:
    """
    Returns true if the subset B of formula is elementary.

    Recall, a subset of closure is elementary if:
    1. it is consistent w.r.t. propositional logic:
      1.a for all \psi \in closure:
        - \psi \in B => \neg \psi \not \in B

      1.b for all \psi_1 land \psi_2 \in closure:
        - \psi_1 land \psi_2 \in B <=> \psi_1 \in B and \psi_2 \in B

    2. it is locally consistent wrt until
      - for all \psi_1 U \psi_2 in closure:
        2.a if \psi_2 in B => \psi_1 U \psi_2 must be in B
        2.b if \psi_2 \not \in B and \psi_1 U \psi_2 in B  => \psi_1 \in B

    3. it is maximal:
      - for all \psi in closure, \psi \in B => \neg \psi \in B

    """

    raise NotImplementedError


def get_elementary(closure : Set[LtlFormula]) -> Set[Set[LtlFormula]]:
    """ Returns the set of all the elementary formula for clousure """
    raise NotImplementedError()




